const crypto = require('crypto');
const { appConfig } = require('../utils/config');

//Signature=md5(AppId + SignatureNonce + ServerSecret + Timestamp)

//生成鉴权，用于与zego服务端通信签名
function GenerateUASignature(appId, serverSecret, stamp, signature) {
    const Timestamp = stamp || Math.round(Date.now() / 1000);
    const SignatureNonce = signature || crypto.randomBytes(8).toString('hex');
    const hash = crypto.createHash('md5'); //规定使用哈希算法中的MD5算法
    const str = appId + SignatureNonce + serverSecret + Timestamp;
    hash.update(str);
    //hash.digest('hex')表示输出的格式为16进制
    return { SignatureNonce, Timestamp, Signature: hash.digest('hex') };
}

function getServerURL(Action, AppId, SignatureVersion = '2.0') {
    const checkKeys = GenerateUASignature(AppId, appConfig[AppId].serverSecret);
    const url = `${appConfig[AppId].host}?Action=${Action}&AppId=${AppId}&SignatureNonce=${checkKeys.SignatureNonce}&Timestamp=${checkKeys.Timestamp}&Signature=${checkKeys.Signature}&SignatureVersion=${SignatureVersion}`;
    console.warn(url);
    return url;
}

exports.GenerateUASignature = GenerateUASignature;
exports.getServerURL = getServerURL;
